#ifndef _ALGORITHM_CATEGORY_HPP_
#define _ALGORITHM_CATEGORY_HPP_

#include <set>
#include <type_traits>
#include <core/xmlApi.hpp>
#include <string>

namespace abstraction {

class AlgorithmCategories {
public:
	enum class AlgorithmCategory {
		DEFAULT,
		TEST,
		STUDENT,
		EFFICIENT,
		NONE
	};

	static AlgorithmCategory algorithmCategory ( const std::string & category );

	static std::string toString ( AlgorithmCategory category );

};

std::ostream & operator << ( std::ostream & os, AlgorithmCategories::AlgorithmCategory category );

} /* namespace abstraction */

namespace alib {

template < >
struct xmlApi < abstraction::AlgorithmCategories::AlgorithmCategory > {
	static abstraction::AlgorithmCategories::AlgorithmCategory parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static std::string xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, abstraction::AlgorithmCategories::AlgorithmCategory category );
};

} /* namespace alib */

#endif // _ALGORITHM_CATEGORY_HPP_
